BUT1 Info - R1.03 - Introduction à l'architecture des ordinateurs
=================================================================

_François Lesueur ([francois.lesueur@univ-ubs.fr](mailto:francois.lesueur@univ-ubs.fr))_

L’objectif de cette ressource est de découvrir la structure et les composants d'un ordinateur. Cette ressource permet de découvrir les différents composants matériels et logiciels internes qui constituent un ordinateur, de manière à appréhender le fonctionnement, mais aussi les limites de leur utilisation.

Savoirs de référence étudiés :
* Architecture générale d'un ordinateur, histoire et évolution de l'informatique
* Codage (codage des informations de base : nombres, caractères)
* Arithmétique des traitements associés
* Étude d’un ordinateur personnel (composants...)
* Évolution des technologies et des systèmes

La matière se déroule du 1/9 au 14/10 et est composée de :
* 6 séances de cours (CM) de 45 minutes (en promo entière)
* 6 séances de travaux dirigés (TD) de 1h30 (en groupe TD)
* 3 séances de travaux pratiques (TP) de 1h30 (en groupe TP, 1 semaine sur 2)

Sur ce dépôt, vous trouverez les notes de cours ainsi que les sujets des TD/TP.

Le programme prévisionnel est le suivant :
* CM :
  - [CM1](cm1-caracteres.md) : Codage des caractères
  - [CM2](cm2-nombres.md) : Codage des entiers et réels
  - CM3 : Architecture d'un ordinateur
  - CM4 : Calcul booléen
  - CM5 : Histoire de l'informatique et des ordinateurs
  - CM6 : Histoire du libre, de l'open-source et du captif
* TD :
  - [TD1](td1-caracteres.md) : Codage des caractères
  - [TD2](td2-entiers.md) : Codage des entiers
  - TD3 : Codage des réels
  - TD4 : Logique booléenne
  - TD5 : Additionneur
  - TD6 : TBA
* TP :
  - [TP1](tp1-encodage.md) : Encodage binaire vers texte
  - TP2 : TBA
  - TP3 : TBA

L'évaluation sera composée d'une note de contrôle continu (1/3, à partir des comptes-rendus demandés) et d'une note d'examen final (2/3).
